//
// Fragment shader for drawing procedural stripes
//
// Author: OGLSL implementation by Ian Nurse
//
// Copyright (C) 2002-2006  LightWork Design Ltd.
//          www.lightworkdesign.com
//
// See LightworkDesign-License.txt for license information
//
#version 110

uniform vec3  StripeColor;
uniform vec3  BackColor;
uniform float Width;
uniform float Fuzz;
uniform float Scale;

varying vec3  DiffuseColor;
varying vec3  SpecularColor;

void main()
{
    float scaled_t = fract(gl_TexCoord[0].t * Scale);
	
    float frac1 = clamp(scaled_t / Fuzz, 0.0, 1.0);
    float frac2 = clamp((scaled_t - Width) / Fuzz, 0.0, 1.0);
float fracx = frac1;
    frac1 = frac1 * (1.0 - frac2);
    float inter;
	// cubic smoothing
	inter = frac1 * frac1 * (3.0 - (2.0 * frac1));
	// exp smoothing
	inter = exp((frac1-1.0)*10.0);
  	//inter =exp (-frac1 * 10.0);
    vec3 finalColor = mix(BackColor, StripeColor, inter);
    finalColor = finalColor * DiffuseColor + SpecularColor;

//	finalColor = mix(BackColor, StripeColor, );
  gl_FragColor = vec4(finalColor, 1.0);
}