//
// Vertex shader for Ward BRDF reflection
//
// Author: Randi Rost
//
// Copyright (c) 2003-2006: 3Dlabs, Inc.
//
// See 3Dlabs-License.txt for license information
//

attribute vec3 tangent;

//uniform vec3 LightDir;  // Light direction in eye coordinates
uniform vec3 LightPosition;
//uniform vec4 ViewPosition;

varying vec3 N, L, H, R, T, B;

void main() 
{
    vec3 V, eyeDir;
    vec4 pos;
	vec4 ecPosition = gl_ModelViewMatrix * gl_Vertex;
	vec4 ViewPosition = normalize(-ecPosition);
       
    pos    = gl_ModelViewMatrix * gl_Vertex;
    eyeDir = pos.xyz;
    
    N = normalize(gl_NormalMatrix * gl_Normal);
    L = normalize(LightPosition);
    V = normalize((gl_ModelViewMatrix * ViewPosition).xyz - pos.xyz);
    H = normalize(L + V);
    R = normalize(reflect(eyeDir, N));
    T = normalize(gl_NormalMatrix * tangent);
	B = normalize(cross(T, N));
    
    gl_Position = ftransform();
}