uniform vec3 BrickColour, MortarColour;
uniform vec2 BrickSize;
uniform vec2 BrickPct;

const float SpecularContribution = 0.3;
const float Attenuation = 40.0;
const float DiffuseContribution = 1.0 - SpecularContribution;

varying vec2 MCposition;
varying vec3 normal, lightVec, viewVec;
varying vec3 tangent_v;

float LightIntensity;

void main()
{
	vec3 colour;
	vec2 position, useBrick;
	float intencity;
	// calculate diffuse
	vec3 lightVecUnit;
	vec3 reflectVec;
	vec3 normalUnit;
	vec3 viewVecUnit;
	float diffuse;
	float specular = 0.0;

	normalUnit = normalize(normal);
	lightVecUnit = normalize(lightVec);
	diffuse = max(dot(lightVecUnit, normalUnit), 0.0);
	
	if (diffuse > 0.0)
	{
		vec3 viewVecUnit		= normalize(viewVec);
		reflectVec = reflect(-lightVecUnit, normalUnit);
//		specular = max(dot(reflectVec, viewVec), 0.0);
		specular = clamp(dot(reflectVec, viewVec), 0.0, 1.0);
		specular = pow(specular, Attenuation);
	}
	
	// light intencity
	LightIntensity = DiffuseContribution * diffuse + SpecularContribution * specular;

	position = MCposition / BrickSize;

	if (fract(position.y * 0.5) > 0.5)	position.x += 0.4;

	position = fract(position);

	useBrick = step(position, BrickPct);

	colour = mix(MortarColour, BrickColour, useBrick.x * useBrick.y);
//colour = vec3(MortarColour);	
//colour = normalize(tangent_v);
//colour = normal;
colour *= LightIntensity;
//colour = vec3(LightIntensity);
	
	gl_FragColor = vec4(colour, 1.0);

}
