
const float SpecularContribution = 0.9;
const float Attenuation = 20.0;
const float DiffuseContribution = 0.9;
const vec3 GlobalAmbient = vec3(0.05, 0.25, 0.35);

const vec2 zCuttoff = vec2(-5.0, -45.0);
//varying vec2 zCuttoff;

varying vec2 MCposition;
varying vec3 normal, lightVec, viewVec;
varying vec3 tangent_v;
varying vec3 vx_pos;

uniform sampler2D tex0;

// fading of the screen
uniform float FadeOut;
uniform float FadeOutAlfa;

float LightIntensity;

void main()
{
	vec3 colour;
	vec2 position, useBrick;
	float intencity;
	// calculate diffuse
	vec3 lightVecUnit;
	vec3 reflectVec;
	vec3 normalUnit;
	vec3 viewVecUnit;
	float diffuse;
	float specular = 0.0;

	normalUnit = normalize(normal);
	lightVecUnit = normalize(lightVec);

	// lighting - diffuse and specular
	diffuse = max(dot(lightVecUnit, normalUnit), 0.0);
	
	if (diffuse > 0.0)
	{
		vec3 viewVecUnit		= normalize(viewVec);
		reflectVec = reflect(lightVecUnit, normalUnit);
		specular = clamp(dot(reflectVec, viewVecUnit), 0.0, 1.0);
		specular = pow(specular, Attenuation);
	}
	
	// light intencity
	LightIntensity = DiffuseContribution * diffuse + SpecularContribution * specular;

	if (vx_pos[2] < zCuttoff[0])
	{
		if (vx_pos[2] < zCuttoff[1])
			LightIntensity = 0.0;
		else
			LightIntensity = smoothstep(zCuttoff[1], zCuttoff[0], vx_pos[2]) * LightIntensity;
	}

	vec3 pixel_value = texture2D(tex0, gl_TexCoord[0].st).rgb;

	if (diffuse > 0.0)
		colour = pixel_value * LightIntensity;
	else
	//	colour = vec3(1.0, 0.4, 0.4);
		colour = vec3(0.0);

	colour = GlobalAmbient + colour;

	gl_FragColor = vec4(colour, FadeOutAlfa);

}
