
const float SpecularContribution = 0.3;
const float Attenuation = 40.0;
const float DiffuseContribution = 1.0 - SpecularContribution;
const float Ambient = 0.2;

varying vec2 MCposition;
varying vec3 normal, lightVec, viewVec;
varying vec3 tangent_v;

uniform sampler2D Noise;

const vec3 SkyColour = vec3(0.2, 0.3, 0.3);
const vec3 CloudColour = vec3(0.9, 0.9, 0.8);

float LightIntensity;

void main()
{
	vec3 colour;
	vec2 position, useBrick;
	float intencity;
	// calculate diffuse
	vec3 lightVecUnit;
	vec3 reflectVec;
	vec3 normalUnit;
	vec3 viewVecUnit;
	float diffuse;
	float specular = 0.0;

	normalUnit = normalize(normal);
	lightVecUnit = normalize(lightVec);
	diffuse = max(dot(lightVecUnit, normalUnit), 0.0);
	
	if (diffuse > 0.0)
	{
		vec3 viewVecUnit		= normalize(viewVec);
		reflectVec = reflect(-lightVecUnit, normalUnit);
//		specular = max(dot(reflectVec, viewVec), 0.0);
		specular = clamp(dot(reflectVec, viewVec), 0.0, 1.0);
		specular = pow(specular, Attenuation);
	}


	
	// light intencity
	LightIntensity = min( 1.0, Ambient + DiffuseContribution * diffuse + SpecularContribution * specular);


	// texturing
	float noise_intc =  texture2D(Noise, gl_TexCoord[0].st).r;

	vec3 LightColor = vec3(mix(SkyColour, CloudColour, noise_intc));

	// marble
	//float sval = sin(MCposition.y * 3.0 + noise_intc * 5.0) * 0.5 * 0.5;
	//vec3 LightColor = vec3(mix(SkyColour, CloudColour, sval));

/*
	// granite
	float noise_gr =  texture2D(Noise, gl_TexCoord[0].st * MCposition).r;
	float intc = min(1.0, noise_gr *3.0);
	vec3 LightColor = vec3(intc);
*/
	
	
	colour = LightColor * LightIntensity;
	
	gl_FragColor = vec4(colour, 1.0);

}
