
const float SpecularContribution = 0.3;
const float Attenuation = 20.0;
const float DiffuseContribution = 1.0 - SpecularContribution;
const vec2 zCuttoff = vec2(-5.0, -45.0);
//varying vec2 zCuttoff;

varying vec2 MCposition;
varying vec3 normal, lightVec, viewVec;
varying vec3 tangent_v;
varying vec3 vx_pos;

// what channels those occupy
#define SpecularMap r
#define CloudAlpha b

uniform sampler2D tex0, Clouds, TexComposite;

float LightDiffuse, LightSpecular;

float diffuseFrag(in vec3 lightv, in vec3 normal)
{
	return max(dot(lightv, normal), 0.0);
}

float specularFrag(in vec3 viewv, in vec3 normal, in vec3 lightv)
{
	vec3 reflectVec;
	float specular;

		vec3 viewVecUnit		= normalize(viewv);
		reflectVec = reflect(-lightv, normal);
		specular = clamp(dot(reflectVec, viewVecUnit), 0.0, 1.0);
		specular = pow( specular, Attenuation);
		return specular;
}

void zFade(inout vec3 value, in float pos_z)
{
	if (pos_z < zCuttoff[0])
	{
		if (pos_z < zCuttoff[1])
		{
			value = vec3(0.0);
		}
		else {
			value = smoothstep(zCuttoff[1], zCuttoff[0], pos_z) * value;
		}
	}
}

void main()
{
	vec3 colour;
	vec2 position, useBrick;
	float intencity;
	// calculate diffuse
	vec3 lightVecUnit;
	vec3 reflectVec;
	vec3 normalUnit;
	vec3 viewVecUnit;
	float diffuse;
	float specular = 0.0;
	float LightValue;

	normalUnit = normalize(normal);
	lightVecUnit = normalize(lightVec);

	float SpecularMap	= texture2D(TexComposite, gl_TexCoord[0].st).r;
	float BumpMap		= texture2D(TexComposite, gl_TexCoord[0].st).g;	float Clouds		= texture2D(TexComposite, gl_TexCoord[0].st).b;
	float NightLights	= texture2D(TexComposite, gl_TexCoord[0].st).a;

	vec3 pixel_value = mix(
		vec3(1.0), 
		texture2D(tex0, gl_TexCoord[0].st).rgb, 
		Clouds
	);

	// zFade(LightValue, vx_pos[2])
	// lighting - diffuse and specular
	diffuse = diffuseFrag(lightVecUnit, normalUnit);

	if (diffuse > 0.0)
	{
		specular = specularFrag(viewVecUnit, normalUnit, lightVecUnit);
		LightValue = DiffuseContribution * diffuse + SpecularContribution * specular * (1.0 - Clouds);
		colour = pixel_value * LightValue;
	} else {
		colour = vec3(1.0, 0.4, 0.4);
	}	

	gl_FragColor = vec4(colour, 1.0);

//	gl_FragColor = vec4(vec3(texture2D(TexComposite, gl_TexCoord[0].st).a), 1.0);

}

